﻿using LibGit2Sharp;
using Newtonsoft.Json;
using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using System.Net;
using System.Security.AccessControl;
using System.Security.Principal;
using System.Text;
using System.Threading.Tasks;

namespace MxWa
{
    public class Addon
    {
        public string name { get; set; }
        public string git { get; set; }
    }

    public class Root
    {
        public List<Addon> addons { get; set; }
    }
    class Program
    {
        public static string version = "1.0.0";

        static void Main(string[] args)
        {
            msg.Splash();

            string listurl = @"https://wow.mikx.xyz/mxwa/addons.json";

            WebClient web = new WebClient();
            var js = web.DownloadString(listurl);
            Root lj = JsonConvert.DeserializeObject<Root>(js);

            foreach (var a in lj.addons)
            {
                if (Directory.Exists($@"AddOns\{a.name}"))
                {
                    msg.CMW($"Fixing [{a.name}] folder permissions...",true,1);
                    FixPermission($@"AddOns\{a.name}");
                    msg.CMW($"Deleting old [{a.name}] files...", true, 1);
                    Directory.Delete($@"AddOns\{a.name}", true);
                    msg.CMW($"Installing latest [{a.name}] data...", true, 1);
                    Repository.Clone(a.git, $@"AddOns\{a.name}");
                }
                else
                {
                    msg.CMW($"Installing latest [{a.name}] data...", true, 1);
                    Repository.Clone(a.git, $@"AddOns\{a.name}");
                }
            }
        }

        static void FixPermission(string path)
        {
            var dl = Directory.GetDirectories(path, "*", SearchOption.AllDirectories);
            foreach (var d in dl)
            {               
                var fl = Directory.GetFiles(d);
                foreach (var f in fl)
                {
                    File.SetAttributes(f, FileAttributes.Normal);
                }
            }
        }
    }
}
